--
-- Patch DDL de CSE du DD/MM/2012 à exécuter depuis le user CSE
--
-- Rem : fichier encodé UTF-8

SET DEFINE OFF;

--
--
-- Fichier : 1
-- Type : DDL
-- Schema : CSE
-- Numero de version : 1.0.0.0
-- Date de publication : 19/09/2012  ==> penser à modifier date dans DML 
-- Auteur(s) : Cocktail
-- Licence : CeCILL version 2
--
--

WHENEVER SQLERROR EXIT SQL.SQLCODE;

--
-- DB_VERSION
--
CREATE TABLE CSE.DB_VERSION 
(
	DBV_ID	NUMBER(4) NOT NULL, 
	DBV_LIBELLE VARCHAR2(15 BYTE) NOT NULL, 
	DBV_DATE	DATE NOT NULL, 
	DBV_INSTALL DATE, 
	DBV_COMMENT	VARCHAR2(2000 BYTE)
);

ALTER TABLE CSE.DB_VERSION ADD ( CONSTRAINT PK_DB_VERSION PRIMARY KEY (DBV_ID) USING INDEX TABLESPACE GRH );
CREATE SEQUENCE CSE.DB_VERSION_SEQ START WITH 1 NOCACHE;

COMMENT ON TABLE CSE.DB_VERSION IS 'Historique des versions du schéma du user CSE'; 
COMMENT ON COLUMN CSE.DB_VERSION.DBV_ID IS 'Identifiant de la version'; 
COMMENT ON COLUMN CSE.DB_VERSION.DBV_LIBELLE IS 'Libelle de la version'; 
COMMENT ON COLUMN CSE.DB_VERSION.DBV_DATE IS 'Date de release de la version'; 
COMMENT ON COLUMN CSE.DB_VERSION.DBV_INSTALL IS 'Date d''installation de la version. Si non renseigné, la version n''est pas complètement installée.';
COMMENT ON COLUMN CSE.DB_VERSION.DBV_COMMENT IS 'Le commentaire : une courte description de cette version de la base de données.';


--
-- CONSTANTE_BUDGET
--
CREATE TABLE CSE.CONSTANTE_BUDGET
(
  ID_CONSTANTE_BUDGET  		NUMBER		 	NOT NULL ,
  C_STRUCTURE 	VARCHAR2(10)	NOT NULL ,
  LL_STRUCTURE 	VARCHAR2(100),
  DOMAINE 	VARCHAR2(10) , 
  ANNEE     	NUMBER(4) 		NOT NULL 
);

ALTER TABLE CSE.CONSTANTE_BUDGET ADD CONSTRAINT PK_CONSTANTE_BUDGET PRIMARY KEY(ID_CONSTANTE_BUDGET);
ALTER TABLE CSE.CONSTANTE_BUDGET ADD CONSTRAINT FK_STRUCTURE FOREIGN KEY (C_STRUCTURE) REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE);

CREATE INDEX CSE.IDX_CB_C_STRUCTURE ON CSE.CONSTANTE_BUDGET(C_STRUCTURE);
CREATE INDEX CSE.IDX_CB_ANNEE ON CSE.CONSTANTE_BUDGET(ANNEE);

CREATE SEQUENCE CSE.CONSTANTE_BUDGET_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.CONSTANTE_BUDGET IS 'Liste des composantes budgétaires dans l''établissement';
COMMENT ON COLUMN CSE.CONSTANTE_BUDGET.ID_CONSTANTE_BUDGET IS 'Clef primaire de la table CONSTANTE_BUDGET';
COMMENT ON COLUMN CSE.CONSTANTE_BUDGET.C_STRUCTURE IS 'Structure concernée (cf. GRHUM.STRUCTURE_ULR.C_STRUCTURE)';
COMMENT ON COLUMN CSE.CONSTANTE_BUDGET.LL_STRUCTURE IS 'Libellé de la structure concernée ';
COMMENT ON COLUMN CSE.CONSTANTE_BUDGET.DOMAINE IS 'Domaine de la structure concernée ';
COMMENT ON COLUMN CSE.CONSTANTE_BUDGET.ANNEE IS 'Année universitaire considérée';



--
-- ELEMENT_MAQUETTE
--
CREATE TABLE CSE.ELEMENT_MAQUETTE
(
  ID_NE  		NUMBER NOT NULL ,
  ID_NE_PERE  		NUMBER ,
  C_ELEMENT_MAQUETTE      VARCHAR2(20) NOT NULL,
  LC_ELEMENT_MAQUETTE   	VARCHAR2(20) ,
  LL_ELEMENT_MAQUETTE   	VARCHAR2(60) ,
  TYPE_ELEMENT		VARCHAR2(20) , 
  ID_CONSTANTE_BUDGET 	NUMBER NOT NULL ,
  SEMESTRE		NUMBER(2), 
  C_TYPE_HORAIRE	VARCHAR2(10) ,
  NB_HEURES_TOTAL	NUMBER ,
  NB_HEURES_MAQUETTE	NUMBER NOT NULL,
  D_CREATION 		DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER ,
  TEM_VALIDE 		VARCHAR2(1 BYTE) DEFAULT 'O' NOT NULL ,
  ANNEE     	 	NUMBER(4) NOT NULL 
);

ALTER TABLE CSE.ELEMENT_MAQUETTE ADD CONSTRAINT PK_ELEMENT_MAQUETTE PRIMARY KEY(ID_NE);
ALTER TABLE CSE.ELEMENT_MAQUETTE ADD CONSTRAINT UK_ELEMENT_MAQUETTE UNIQUE (C_ELEMENT_MAQUETTE);
ALTER TABLE CSE.ELEMENT_MAQUETTE ADD CONSTRAINT FK_EM_ELEMENT_MAQUETTE FOREIGN KEY (ID_NE_PERE) REFERENCES CSE.ELEMENT_MAQUETTE (ID_NE);
ALTER TABLE CSE.ELEMENT_MAQUETTE ADD CONSTRAINT FK_EM_CONSTANTE_BUDGET FOREIGN KEY (ID_CONSTANTE_BUDGET) REFERENCES CSE.CONSTANTE_BUDGET (ID_CONSTANTE_BUDGET);
ALTER TABLE CSE.ELEMENT_MAQUETTE ADD CONSTRAINT FK_EM_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.ELEMENT_MAQUETTE ADD CONSTRAINT FK_EM_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.ELEMENT_MAQUETTE ADD CONSTRAINT CHK_EM_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );


CREATE INDEX CSE.IDX_ID_NE_CB ON CSE.ELEMENT_MAQUETTE(ID_CONSTANTE_BUDGET);
CREATE INDEX CSE.IDX_NE_NE_TYPE ON CSE.ELEMENT_MAQUETTE(TYPE_ELEMENT);
CREATE INDEX CSE.IDX_NE_NE_ANNEE ON CSE.ELEMENT_MAQUETTE(ANNEE);

CREATE SEQUENCE CSE.ELEMENT_MAQUETTE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.ELEMENT_MAQUETTE IS 'Nomenclature des éléments présents dans l''offre de formation.';    
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.ID_NE IS 'Clef primaire de la table ELEMENT_MAQUETTE';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.ID_NE_PERE IS 'Référence à l''élement immédiatement supérieur dans ELEMENT_MAQUETTE';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.C_ELEMENT_MAQUETTE IS 'Code de l''élément';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.LC_ELEMENT_MAQUETTE IS 'Libellé court de l''élément';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.LL_ELEMENT_MAQUETTE IS 'Libellé long de l''élément';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.TYPE_ELEMENT IS 'Type de l''élément : Parcours, Semestre, UE,...';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.ID_CONSTANTE_BUDGET IS 'Composante budgétaire de l''élément (cf. CSE.CONSTANTE_BUDGET.ID_CONSTANTE_BUDGET)';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.SEMESTRE IS 'Semestre de l''élément';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.C_TYPE_HORAIRE IS 'Détail du type du plus petit élement : CM, TD, TP,...';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.NB_HEURES_TOTAL IS 'Nombre d''heures total en fonction du nombre de groupe d''étudiants';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.NB_HEURES_MAQUETTE IS 'Nombre d''heures initialement prévues dans la maquette';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.TEM_VALIDE IS 'Validité de l''enregistrement ? (O:valide, N:invalide) ';
COMMENT ON COLUMN CSE.ELEMENT_MAQUETTE.ANNEE IS 'Année universitaire considérée';

--
-- ARRETE
--
CREATE TABLE CSE.ARRETE
(
  ID_ARRETE  	NUMBER	NOT NULL ,
  D_ARRETE 	DATE DEFAULT SYSDATE 	NOT NULL ,
  SEMESTRE  NUMBER(1) NOT NULL ,
  TEM_VALIDE 	VARCHAR2(1) DEFAULT 'O' NOT NULL ,
  ANNEE     NUMBER(4) NOT NULL 
);
 

ALTER TABLE CSE.ARRETE ADD CONSTRAINT PK_ARRETE PRIMARY KEY(ID_ARRETE);
ALTER TABLE CSE.ARRETE ADD CONSTRAINT CHK_ARR_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );

CREATE SEQUENCE CSE.ARRETE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.ARRETE IS 'Liste des arrêtés pour les heures complémentaires dans l''établissement';
COMMENT ON COLUMN CSE.ARRETE.ID_ARRETE IS 'Clef primaire de la table ARRETE';
COMMENT ON COLUMN CSE.ARRETE.D_ARRETE IS 'Date de création de l''arrêté';
COMMENT ON COLUMN CSE.ARRETE.SEMESTRE IS 'Semestre universitaire considéré';
COMMENT ON COLUMN CSE.ARRETE.TEM_VALIDE IS 'Validité de l''enregistrement ? (O:valide, N:invalide) ';
COMMENT ON COLUMN CSE.ARRETE.ANNEE IS 'Année universitaire considérée';


--
-- LIGNE_ARRETE
--
CREATE TABLE CSE.LIGNE_ARRETE
(
  ID_LIGNE_ARRETE NUMBER NOT NULL ,
  ID_ARRETE  	NUMBER	NOT NULL ,
  NO_INDIVIDU   NUMBER(8, 0)	NOT NULL ,
  ID_CONSTANTE_BUDGET		NUMBER			NOT NULL ,
  TEM_VALIDE 	VARCHAR2(1) DEFAULT 'O' NOT NULL 
);


ALTER TABLE CSE.LIGNE_ARRETE ADD CONSTRAINT PK_LIGNE_ARRETE PRIMARY KEY(ID_LIGNE_ARRETE);
ALTER TABLE CSE.LIGNE_ARRETE ADD CONSTRAINT FK_LA_ARRETE FOREIGN KEY (ID_ARRETE) REFERENCES CSE.ARRETE (ID_ARRETE);
ALTER TABLE CSE.LIGNE_ARRETE ADD CONSTRAINT FK_LA_INDIVIDU FOREIGN KEY (NO_INDIVIDU) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE CSE.LIGNE_ARRETE ADD CONSTRAINT FK_LA_CONSTANTE_BUDGET FOREIGN KEY (ID_CONSTANTE_BUDGET) REFERENCES CSE.CONSTANTE_BUDGET (ID_CONSTANTE_BUDGET);
ALTER TABLE CSE.LIGNE_ARRETE ADD CONSTRAINT CHK_LA_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );

CREATE INDEX CSE.IDX_LA_ID_ARRETE ON CSE.LIGNE_ARRETE(ID_ARRETE);
CREATE INDEX CSE.IDX_LA_NO_INDIVIDU ON CSE.LIGNE_ARRETE(NO_INDIVIDU);
CREATE INDEX CSE.IDX_LA_ID_CB ON CSE.LIGNE_ARRETE(ID_CONSTANTE_BUDGET);

CREATE SEQUENCE CSE.LIGNE_ARRETE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.LIGNE_ARRETE IS 'Détails d''un arrêté avec la liste des intervenants';
COMMENT ON COLUMN CSE.LIGNE_ARRETE.ID_LIGNE_ARRETE IS 'Clef primaire de la table LIGNE_ARRETE';
COMMENT ON COLUMN CSE.LIGNE_ARRETE.ID_ARRETE IS 'Arrêté concerné (cf. CSE.ARRETE.ID_ARRETE)';
COMMENT ON COLUMN CSE.LIGNE_ARRETE.NO_INDIVIDU IS 'Intervenant concerné (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN CSE.LIGNE_ARRETE.ID_CONSTANTE_BUDGET IS 'Composante budgétaire attachée à la prestation (cf. CSE.CONSTANTE_BUDGET.ID_CONSTANTE_BUDGET)';
COMMENT ON COLUMN CSE.LIGNE_ARRETE.TEM_VALIDE IS 'Validité de l''enregistrement ? (O:valide, N:invalide) ';



--
--  REH
--
CREATE TABLE CSE.REH
(
  ID_REH		NUMBER(8) NOT NULL ,
  LC_REH   		VARCHAR2(64) ,
  LL_REH   		VARCHAR2(128) ,
  DESCRIPTION 		VARCHAR2(2048) ,
  COMMENTAIRE 		VARCHAR2(1024) ,
  ID_NE  		NUMBER ,
  D_DEBUT 		DATE DEFAULT SYSDATE NOT NULL,
  D_FIN  		DATE DEFAULT SYSDATE ,
  D_CREATION 		DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER  
);

ALTER TABLE CSE.REH ADD CONSTRAINT PK_REH PRIMARY KEY(ID_REH);
ALTER TABLE CSE.REH ADD CONSTRAINT FK_REH_ELEMENT_MAQUETTE FOREIGN KEY (ID_NE) REFERENCES CSE.ELEMENT_MAQUETTE (ID_NE);
ALTER TABLE CSE.REH ADD CONSTRAINT FK_REH_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.REH ADD CONSTRAINT FK_REH_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE INDEX CSE.IDX_REH_ID_NE ON CSE.REH(ID_NE);
CREATE SEQUENCE CSE.REH_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.REH IS 'Table des activités du Réferentiel des Equivalences Horaires';    
COMMENT ON COLUMN CSE.REH.ID_REH IS 'Clef primaire de la table REH';
COMMENT ON COLUMN CSE.REH.LC_REH IS 'Libellé court de l''activité REH';
COMMENT ON COLUMN CSE.REH.LL_REH IS 'Libellé long de l''activité REH';
COMMENT ON COLUMN CSE.REH.DESCRIPTION IS 'Description de l''activité REH';
COMMENT ON COLUMN CSE.REH.COMMENTAIRE IS 'Commentaire avec les méthodes de calcul de l''activité REH';
COMMENT ON COLUMN CSE.REH.ID_NE IS 'référence à un élément présent dans l''offre de formation (cf. CSE.ELEMENT_MAQUETTE.ID_NE)';
COMMENT ON COLUMN CSE.REH.D_DEBUT IS 'Date du début de l''activité REH';
COMMENT ON COLUMN CSE.REH.D_FIN IS 'Date du fin de l''activité REH';
COMMENT ON COLUMN CSE.REH.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.REH.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.REH.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.REH.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- SERVICE
--
CREATE TABLE CSE.SERVICE
(
  ID_SERVICE		NUMBER	NOT NULL ,
  NO_INDIVIDU    	NUMBER(8, 0) NOT NULL ,
  ID_NE  		NUMBER	,
  ID_REH  		NUMBER(8) ,
  HEURES_PREVUES 	NUMBER	DEFAULT 0 NOT NULL ,
  HEURES_REALISEES	NUMBER	DEFAULT 0 NOT NULL ,
  ID_DEMANDE 		NUMBER ,
  TEM_PAYE 		VARCHAR2(1) DEFAULT 'N' NOT NULL ,
  TEM_VALIDE 		VARCHAR2(1) DEFAULT 'O' NOT NULL , 
  COMMENTAIRE 		VARCHAR2(1024) ,
  D_COMMENTAIRE  	DATE ,
  ANNEE 		NUMBER(4) NOT NULL 
);


ALTER TABLE CSE.SERVICE ADD CONSTRAINT PK_SERVICE PRIMARY KEY(ID_SERVICE);
ALTER TABLE CSE.SERVICE ADD CONSTRAINT FK_INDIVIDU_ULR FOREIGN KEY (NO_INDIVIDU) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE CSE.SERVICE ADD CONSTRAINT FK_SER_ELEMENT_MAQUETTE FOREIGN KEY (ID_NE) REFERENCES CSE.ELEMENT_MAQUETTE (ID_NE);
ALTER TABLE CSE.SERVICE ADD CONSTRAINT FK_SER_REH FOREIGN KEY (ID_REH) REFERENCES CSE.REH (ID_REH);
ALTER TABLE CSE.SERVICE ADD CONSTRAINT FK_SER_ID_DEMANDE FOREIGN KEY (ID_DEMANDE) REFERENCES CSE.DEMANDE (ID_DEMANDE);
ALTER TABLE CSE.SERVICE ADD CONSTRAINT CHK_SER_TEM_PAYE CHECK (TEM_PAYE IN ('O', 'N') );
ALTER TABLE CSE.SERVICE ADD CONSTRAINT CHK_SER_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );
ALTER TABLE CSE.SERVICE ADD CONSTRAINT NE_REH_NULLS CHECK (ID_NE IS NOT NULL OR ID_REH IS NOT NULL);
ALTER TABLE CSE.SERVICE ADD CONSTRAINT NE_REH_NOT_NULLS CHECK (ID_NE IS NULL OR ID_REH IS NULL);

CREATE INDEX CSE.IDX_SER_NO_INDIVIDU ON CSE.SERVICE(NO_INDIVIDU);
CREATE INDEX CSE.IDX_SER_ID_NE ON CSE.SERVICE(ID_NE);
CREATE INDEX CSE.IDX_SER_ID_REH ON CSE.SERVICE(ID_REH);
CREATE INDEX CSE.IDX_SER_ID_DEMANDE ON CSE.SERVICE(ID_DEMANDE);
CREATE INDEX CSE.IDX_SER_ANNEE ON CSE.SERVICE(ANNEE);

CREATE SEQUENCE CSE.SERVICE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.SERVICE IS 'Fiche de service d''un intervenant';
COMMENT ON COLUMN CSE.SERVICE.ID_SERVICE IS 'Clef primaire de la table SERVICE';
COMMENT ON COLUMN CSE.SERVICE.NO_INDIVIDU IS 'Intervenant concerné (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN CSE.SERVICE.ID_NE IS 'référence à un élément présent dans l''offre de formation où intervient l''enseignant (cf. CSE.ELEMENT_MAQUETTE.ID_NE)';
COMMENT ON COLUMN CSE.SERVICE.ID_REH IS 'référence à une activité REH dans laquelle intervient l''enseignant (cf. CSE.REH.ID_REH)';
COMMENT ON COLUMN CSE.SERVICE.HEURES_PREVUES IS 'Heures prévues dans le service de l''intervenant';
COMMENT ON COLUMN CSE.SERVICE.HEURES_REALISEES IS 'Heures réalisées dans le service de l''intervenant';
COMMENT ON COLUMN CSE.SERVICE.ID_DEMANDE IS 'Référence à la demande sur le circuit de validation (cf. CSE.DEMANDE.ID_DEMANDE)';
COMMENT ON COLUMN CSE.SERVICE.TEM_PAYE IS 'Intervenant payé (O:oui, N:non) ';
COMMENT ON COLUMN CSE.SERVICE.TEM_VALIDE IS 'Validité de l''enregistrement ? (O:valide, N:invalide) ';
COMMENT ON COLUMN CSE.SERVICE.COMMENTAIRE IS 'Commentaire sur la fiche de service';
COMMENT ON COLUMN CSE.SERVICE.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN CSE.SERVICE.ANNEE IS 'Année universitaire considérée';




--
-- FICHE_VOEUX
--
CREATE TABLE CSE.FICHE_VOEUX
(
  ID_FICHE_VOEUX	NUMBER	NOT NULL ,
  NO_INDIVIDU    	NUMBER(8, 0) NOT NULL ,
  ID_NE	 		NUMBER ,
  HEURES_SOUHAITEES 	NUMBER	DEFAULT 0 NOT NULL ,
  C_STRUCTURE 		VARCHAR2(10) ,
  COMMENTAIRE 		VARCHAR2(1024) ,
  D_COMMENTAIRE  	DATE DEFAULT SYSDATE ,
  ANNEE 		NUMBER(4) NOT NULL 
);

ALTER TABLE CSE.FICHE_VOEUX ADD CONSTRAINT PK_FICHE_VOEUX PRIMARY KEY(ID_FICHE_VOEUX);
ALTER TABLE CSE.FICHE_VOEUX ADD CONSTRAINT FK_FV_INDIVIDU FOREIGN KEY (NO_INDIVIDU) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE CSE.FICHE_VOEUX ADD CONSTRAINT FK_FV_ELEMENT_MAQUETTE FOREIGN KEY (ID_NE) REFERENCES CSE.ELEMENT_MAQUETTE (ID_NE);
ALTER TABLE CSE.FICHE_VOEUX ADD CONSTRAINT FK_FV_STRUCTURE FOREIGN KEY (C_STRUCTURE) REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE);
-- Un des 2 identifiants (ID_NE, C_Structure) doit être renseigné au plus, mais également un des deux doit être renseigné au moins.
ALTER TABLE CSE.FICHE_VOEUX ADD CONSTRAINT FV_NE_STRUCTURE_NULLS CHECK (ID_NE IS NOT NULL OR C_STRUCTURE IS NOT NULL);
ALTER TABLE CSE.FICHE_VOEUX ADD CONSTRAINT FV_NE_STRUCTURE_NOT_NULLS CHECK (ID_NE IS NULL OR C_STRUCTURE IS NULL);


CREATE INDEX CSE.IDX_FV_NO_INDIVIDU ON CSE.FICHE_VOEUX(NO_INDIVIDU);
CREATE INDEX CSE.IDX_FV_ID_NE ON CSE.FICHE_VOEUX(ID_NE);
CREATE INDEX CSE.IDX_FV_C_STRUCTURE ON CSE.FICHE_VOEUX(C_STRUCTURE);

CREATE SEQUENCE CSE.FICHE_VOEUX_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.FICHE_VOEUX IS 'Fiche de voeux d''un enseignant';
COMMENT ON COLUMN CSE.FICHE_VOEUX.ID_FICHE_VOEUX IS 'Clef primaire de la table FICHE_VOEUX';
COMMENT ON COLUMN CSE.FICHE_VOEUX.NO_INDIVIDU IS 'Enseignant concerné (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN CSE.FICHE_VOEUX.ID_NE IS 'référence à un élément présent dans l''offre de formation où intervient l''enseignant (cf. CSE.ELEMENT_MAQUETTE.ID_NE)';
COMMENT ON COLUMN CSE.FICHE_VOEUX.HEURES_SOUHAITEES IS 'Nombre d''heures souhaitées par l''intervenant';
COMMENT ON COLUMN CSE.FICHE_VOEUX.C_STRUCTURE IS 'Structure concernée (cf. GRHUM.STRUCTURE_ULR.C_STRUCTURE), uniquement dans le cadre d''un autre établissement';
COMMENT ON COLUMN CSE.FICHE_VOEUX.COMMENTAIRE IS 'Commentaire sur la fiche de voeux';
COMMENT ON COLUMN CSE.FICHE_VOEUX.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN CSE.FICHE_VOEUX.ANNEE IS 'Année universitaire considérée';  


--
-- ENSEIGNANT_GENERIQUE
--
CREATE TABLE CSE.ENSEIGNANT_GENERIQUE
(
  ID_ENSEIGNANT_GENERIQUE	NUMBER	NOT NULL ,
  NOM		 		VARCHAR2(30) ,
  PRENOM		 	VARCHAR2(30) ,
  ID_NE  		 	NUMBER	NOT NULL ,
  HEURES_PREVUES 	NUMBER	DEFAULT 0 NOT NULL ,
  TEM_VALIDE 			VARCHAR2(1) DEFAULT 'O' NOT NULL , 
  COMMENTAIRE 		VARCHAR2(1024) ,
  D_COMMENTAIRE  		DATE DEFAULT SYSDATE ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER , 
  ID_CORPS NUMBER
);


ALTER TABLE CSE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT PK_ENSEIGNANT_GENERIQUE PRIMARY KEY(ID_ENSEIGNANT_GENERIQUE);
ALTER TABLE CSE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT FK_EG_ELEMENT_MAQUETTE FOREIGN KEY (ID_NE) REFERENCES CSE.ELEMENT_MAQUETTE (ID_NE);
ALTER TABLE CSE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT FK_EG_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT FK_EG_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT CHK_EG_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );

CREATE INDEX CSE.IDX_EG_ID_NE ON CSE.ENSEIGNANT_GENERIQUE(ID_NE);

CREATE SEQUENCE CSE.ENSEIGNANT_GENERIQUE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.ENSEIGNANT_GENERIQUE IS 'Table qui permet d''affecter des heures prévisionnelles à un intervenant s''il n''est pas encore renseigné dans MANGUE';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.ID_ENSEIGNANT_GENERIQUE IS 'Clef primaire de la table ENSEIGNANT_GENERIQUE';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.NOM IS 'Nom de l''intervenant si connu';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.PRENOM IS 'Prénom de l''intervenant si connu';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.ID_NE IS 'Référence à un élément présent dans l''offre de formation (cf. CSE.ELEMENT_MAQUETTE.ID_NE)';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.HEURES_PREVUES IS 'Heures prévues pour l''intervenant';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.TEM_VALIDE IS 'Validité de l''enregistrement ? (O:valide, N:invalide) ';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.COMMENTAIRE IS 'Commentaire sur l''intervenant';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.ENSEIGNANT_GENERIQUE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
--  PRIORITE_COMPOSANTE
--
CREATE TABLE CSE.PRIORITE_COMPOSANTE
(
  ID_PRIORITE_COMPOSANTE	NUMBER	NOT NULL ,
  C_STRUCTURE 			VARCHAR2(10) NOT NULL ,
  PRIORITE_MAX		NUMBER(1)	NOT NULL ,
  TEM_VALIDE 			VARCHAR2(1) DEFAULT 'O' NOT NULL , 
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER ,
  ANNEE 				NUMBER(4) NOT NULL
);

ALTER TABLE CSE.PRIORITE_COMPOSANTE  ADD CONSTRAINT PK_PRIORITE_COMPOSANTE  PRIMARY KEY(ID_PRIORITE_COMPOSANTE);
ALTER TABLE CSE.PRIORITE_COMPOSANTE ADD CONSTRAINT FK_PC_STRUCTURE FOREIGN KEY (C_STRUCTURE) REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE);
ALTER TABLE CSE.PRIORITE_COMPOSANTE  ADD CONSTRAINT FK_PC_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.PRIORITE_COMPOSANTE  ADD CONSTRAINT FK_PC_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.PRIORITE_COMPOSANTE  ADD CONSTRAINT CHK_PC_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );

CREATE INDEX CSE.IDX_PC_C_STRUCTURE ON CSE.PRIORITE_COMPOSANTE (C_STRUCTURE);

CREATE SEQUENCE CSE.PRIORITE_COMPOSANTE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;


COMMENT ON TABLE CSE.PRIORITE_COMPOSANTE  IS 'Table qui définit la priorité maximale choisie par chaque composante';
COMMENT ON COLUMN CSE.PRIORITE_COMPOSANTE.ID_PRIORITE_COMPOSANTE IS 'Clef primaire de la table PRIORITE_COMPOSANTE ';
COMMENT ON COLUMN CSE.PRIORITE_COMPOSANTE.C_STRUCTURE IS 'Composante concernée (cf. GRHUM.STRUCTURE_ULR.C_STRUCTURE)';
COMMENT ON COLUMN CSE.PRIORITE_COMPOSANTE.PRIORITE_MAX IS 'priorité maximale choisie par la composante';
COMMENT ON COLUMN CSE.PRIORITE_COMPOSANTE.TEM_VALIDE IS 'Validité de l''enregistrement ? (O:valide, N:invalide) ';
COMMENT ON COLUMN CSE.PRIORITE_COMPOSANTE.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN CSE.PRIORITE_COMPOSANTE.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN CSE.PRIORITE_COMPOSANTE.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.PRIORITE_COMPOSANTE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';
COMMENT ON COLUMN CSE.PRIORITE_COMPOSANTE.ANNEE IS 'Année universitaire considérée';  


--
--  PRIORITE_ENSEIGNANT
--
CREATE TABLE CSE.PRIORITE_ENSEIGNANT 
(
  ID_PRIORITE_ENSEIGNANT	NUMBER	NOT NULL ,
  NO_INDIVIDU    		NUMBER(8, 0) NOT NULL ,
  ID_NE  		 		NUMBER	NOT NULL ,
  ORDRE			 	NUMBER(1)	NOT NULL ,
  ID_PRIORITE_COMPOSANTE	NUMBER	NOT NULL ,
  TEM_VALIDE 			VARCHAR2(1) DEFAULT 'O' NOT NULL , 
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER ,
  ANNEE 				NUMBER(4) NOT NULL
);

ALTER TABLE CSE.PRIORITE_ENSEIGNANT  ADD CONSTRAINT PK_PRIORITE_ENSEIGNANT  PRIMARY KEY(ID_PRIORITE_ENSEIGNANT);
ALTER TABLE CSE.PRIORITE_ENSEIGNANT  ADD CONSTRAINT FK_PE_INDIVIDU FOREIGN KEY (NO_INDIVIDU) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE CSE.PRIORITE_ENSEIGNANT  ADD CONSTRAINT FK_PE_ELEMENT_MAQUETTE FOREIGN KEY (ID_NE) REFERENCES CSE.ELEMENT_MAQUETTE (ID_NE);
ALTER TABLE CSE.PRIORITE_ENSEIGNANT  ADD CONSTRAINT FK_PE_PRIORITE_COMPOSANTE FOREIGN KEY (ID_PRIORITE_COMPOSANTE) REFERENCES CSE.PRIORITE_COMPOSANTE (ID_PRIORITE_COMPOSANTE);
ALTER TABLE CSE.PRIORITE_ENSEIGNANT  ADD CONSTRAINT FK_PE_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.PRIORITE_ENSEIGNANT  ADD CONSTRAINT FK_PE_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.PRIORITE_ENSEIGNANT  ADD CONSTRAINT CHK_PE_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );

CREATE INDEX CSE.IDX_PE_NO_INDIVIDU ON CSE.PRIORITE_ENSEIGNANT (NO_INDIVIDU);
CREATE INDEX CSE.IDX_PE_ID_NE ON CSE.PRIORITE_ENSEIGNANT (ID_NE);
CREATE INDEX CSE.IDX_PE_ID_PC ON CSE.PRIORITE_ENSEIGNANT (ID_PRIORITE_COMPOSANTE);

CREATE SEQUENCE CSE.PRIORITE_ENSEIGNANT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;


COMMENT ON TABLE CSE.PRIORITE_ENSEIGNANT  IS 'Table qui définit la priorité d''un enseignant sur un élément de l''offre de formation';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.ID_PRIORITE_ENSEIGNANT IS 'Clef primaire de la table PRIORITE_ENSEIGNANT ';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.NO_INDIVIDU IS 'Enseignant concerné (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.ID_NE IS 'Référence à un élément présent dans l''offre de formation (cf. CSE.ELEMENT_MAQUETTE.ID_NE)';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.ORDRE IS 'Priorité de l''intervenant pour l''année en cours';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.ID_PRIORITE_COMPOSANTE IS 'Composante concernée (cf. CSE.PRIORITE_COMPOSANTE.ID_PRIORITE_COMPOSANTE)';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.TEM_VALIDE IS 'Validité de l''enregistrement ? (O:valide, N:invalide) ';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';
COMMENT ON COLUMN CSE.PRIORITE_ENSEIGNANT.ANNEE IS 'Année universitaire considérée';  


--
--  PLAFOND_HEURES_COMPOSANTE
--
CREATE TABLE CSE.PLAFOND_HEURES_COMPOSANTE
(
  ID_PLAFOND_COMPOSANTE		 		NUMBER	NOT NULL ,
  C_STRUCTURE 			VARCHAR2(10) NOT NULL ,
  NON_VACATAIRES 	NUMBER ,
  SPECIAL_VACATAIRE NUMBER ,
  AUTRES_VACATAIRES NUMBER ,
  TEM_VALIDE 			VARCHAR2(1) DEFAULT 'O' NOT NULL , 
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER ,
  ANNEE 			NUMBER(4) NOT NULL
);

ALTER TABLE CSE.PLAFOND_HEURES_COMPOSANTE  ADD CONSTRAINT PK_PLAFOND_HEURES_COMPOSANTE  PRIMARY KEY(ID_PLAFOND_COMPOSANTE);
ALTER TABLE CSE.PLAFOND_HEURES_COMPOSANTE ADD CONSTRAINT FK_PHC_STRUCTURE FOREIGN KEY (C_STRUCTURE) REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE);
ALTER TABLE CSE.PLAFOND_HEURES_COMPOSANTE  ADD CONSTRAINT FK_PHC_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.PLAFOND_HEURES_COMPOSANTE  ADD CONSTRAINT FK_PHC_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.PLAFOND_HEURES_COMPOSANTE  ADD CONSTRAINT CHK_PHC_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );

CREATE INDEX CSE.IDX_PHC_C_STRUCTURE ON CSE.PLAFOND_HEURES_COMPOSANTE (C_STRUCTURE);

CREATE SEQUENCE CSE.PLAFOND_HEURES_COMPOSANTE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;


COMMENT ON TABLE CSE.PLAFOND_HEURES_COMPOSANTE  IS 'Table qui définit le plafond d''heures maximal en Heures Equivalents TD choisi par chaque composante pour Vacataires et Non Vacataires';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.ID_PLAFOND_COMPOSANTE IS 'Clef primaire de la table PLAFOND_HEURES_COMPOSANTE ';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.C_STRUCTURE IS 'Composante concernée (cf. GRHUM.STRUCTURE_ULR.C_STRUCTURE)';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.NON_VACATAIRES IS 'Plafond d''heures maximal pour les non vacataires';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.SPECIAL_VACATAIRE IS 'Plafond d''heures maximal pour une catégorie spéciale de vacataires';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.AUTRES_VACATAIRES IS 'Plafond d''heures maximal pour les autres vacataires';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.TEM_VALIDE IS 'Validité de l''enregistrement ? (O:valide, N:invalide) ';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';
COMMENT ON COLUMN CSE.PLAFOND_HEURES_COMPOSANTE.ANNEE IS 'Année universitaire considérée'; 


--
-- REPORT
--
CREATE TABLE CSE.REPORT
(
  ID_REPORT		 		NUMBER	NOT NULL ,
  NO_INDIVIDU    		NUMBER(8, 0) NOT NULL ,
  HEURES_SOUHAITEES NUMBER	DEFAULT 0 NOT NULL ,
  HEURES_ATTRIBUEES NUMBER	DEFAULT 0 NOT NULL ,
  COMMENTAIRE 		VARCHAR2(1024) ,
  D_COMMENTAIRE  		DATE DEFAULT SYSDATE ,
  ANNEE 			NUMBER(4) NOT NULL 
);

ALTER TABLE CSE.REPORT ADD CONSTRAINT PK_REPORT PRIMARY KEY(ID_REPORT);
ALTER TABLE CSE.REPORT ADD CONSTRAINT FK_REP_INDIVIDU FOREIGN KEY (NO_INDIVIDU) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);

CREATE INDEX CSE.IDX_REP_NO_INDIVIDU ON CSE.REPORT(NO_INDIVIDU);
CREATE INDEX CSE.IDX_REP_ANNEE ON CSE.REPORT(ANNEE);

CREATE SEQUENCE CSE.REPORT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.REPORT IS 'report demandé des heures complémentaires par un enseignant';
COMMENT ON COLUMN CSE.REPORT.ID_REPORT IS 'Clef primaire de la table REPORT';
COMMENT ON COLUMN CSE.REPORT.NO_INDIVIDU IS 'Enseignant qui demande le report d''heures (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN CSE.REPORT.HEURES_SOUHAITEES IS 'Nombre d''heures  de report souhaité par l''intervenant';
COMMENT ON COLUMN CSE.REPORT.HEURES_ATTRIBUEES IS 'Nombre d''heures de report attribué à l''intervenant';
COMMENT ON COLUMN CSE.REPORT.COMMENTAIRE IS 'Commentaire sur le report de l''enseignant';
COMMENT ON COLUMN CSE.REPORT.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN CSE.REPORT.ANNEE IS 'Année universitaire considérée';  


--
-- DEPASSEMENT_PLAFOND
--
CREATE TABLE CSE.DEPASSEMENT_PLAFOND
(
  ID_DEPASSEMENT_PLAFOND	NUMBER	NOT NULL ,
  ID_SERVICE		 		NUMBER	NOT NULL ,
  HEURES_SOUHAITEES 	NUMBER	DEFAULT 0 NOT NULL ,
  HEURES_ATTRIBUEES 	NUMBER	DEFAULT 0 NOT NULL ,
  MOTIF 				VARCHAR2(1024) ,
  COMMENTAIRE 		VARCHAR2(512) ,
  D_COMMENTAIRE  		DATE DEFAULT SYSDATE ,
  ANNEE 				NUMBER(4) NOT NULL 
);

ALTER TABLE CSE.DEPASSEMENT_PLAFOND ADD CONSTRAINT PK_DEPASSEMENT_PLAFOND PRIMARY KEY(ID_DEPASSEMENT_PLAFOND);
ALTER TABLE CSE.DEPASSEMENT_PLAFOND ADD CONSTRAINT FK_DP_SERVICE FOREIGN KEY (ID_SERVICE) REFERENCES CSE.SERVICE (ID_SERVICE);

CREATE INDEX CSE.IDX_DP_ID_SER ON CSE.DEPASSEMENT_PLAFOND(ID_SERVICE);
CREATE INDEX CSE.IDX_DP_ANNEE ON CSE.DEPASSEMENT_PLAFOND(ANNEE);

CREATE SEQUENCE CSE.DEPASSEMENT_PLAFOND_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.DEPASSEMENT_PLAFOND IS 'Demande de dépassement de plafond des heures complémentaires';
COMMENT ON COLUMN CSE.DEPASSEMENT_PLAFOND.ID_DEPASSEMENT_PLAFOND IS 'Clef primaire de la table DEPASSEMENT_PLAFOND';
COMMENT ON COLUMN CSE.DEPASSEMENT_PLAFOND.ID_SERVICE IS 'Fiche de service sur laquelle porte le dépassement de plafond (cf. CSE.SERVICE.ID_SER)';
COMMENT ON COLUMN CSE.DEPASSEMENT_PLAFOND.HEURES_SOUHAITEES IS 'Nombre d''heures souhaité pour le dépassement de plafond';
COMMENT ON COLUMN CSE.DEPASSEMENT_PLAFOND.HEURES_ATTRIBUEES IS 'Nombre d''heures  attribué pour le dépassement de plafond';
COMMENT ON COLUMN CSE.DEPASSEMENT_PLAFOND.MOTIF IS 'Motif de demande du dépassement de plafond';
COMMENT ON COLUMN CSE.DEPASSEMENT_PLAFOND.COMMENTAIRE IS 'Commentaire sur le dépassement de plafond';
COMMENT ON COLUMN CSE.DEPASSEMENT_PLAFOND.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN CSE.DEPASSEMENT_PLAFOND.ANNEE IS 'Année universitaire considérée';


--
-- TYPE_EDITION
--
CREATE TABLE CSE.TYPE_EDITION
(
  ID_TYPE_EDITION  		NUMBER NOT NULL ,
  C_TYPE_EDITION	VARCHAR2(2) NOT NULL ,
  LC_TYPE_EDITION   	VARCHAR2(20) ,
  LL_TYPE_EDITION   	VARCHAR2(60) ,
  D_CREATION 		DATE DEFAULT SYSDATE 	NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE 	NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER  
);

ALTER TABLE CSE.TYPE_EDITION ADD CONSTRAINT PK_TYPE_EDITION PRIMARY KEY(ID_TYPE_EDITION);
ALTER TABLE CSE.TYPE_EDITION ADD CONSTRAINT UK_TYPE_EDITION UNIQUE (C_TYPE_EDITION);
ALTER TABLE CSE.TYPE_EDITION ADD CONSTRAINT FK_TE_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.TYPE_EDITION ADD CONSTRAINT FK_TE_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE SEQUENCE CSE.TYPE_EDITION_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.TYPE_EDITION IS 'Nomenclature des types d''édition';    
COMMENT ON COLUMN CSE.TYPE_EDITION.ID_TYPE_EDITION IS 'Clef primaire de la table TYPE_EDITION';
COMMENT ON COLUMN CSE.TYPE_EDITION.C_TYPE_EDITION IS 'Code du type d''édition';
COMMENT ON COLUMN CSE.TYPE_EDITION.LC_TYPE_EDITION IS 'Libellé court du type d''édition';
COMMENT ON COLUMN CSE.TYPE_EDITION.LL_TYPE_EDITION IS 'Libellé long du type d''édition';
COMMENT ON COLUMN CSE.TYPE_EDITION.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.TYPE_EDITION.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.TYPE_EDITION.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.TYPE_EDITION.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- IMPRESSION
--
CREATE TABLE CSE.IMPRESSION
(
  ID_IMPRESSION  	NUMBER	NOT NULL ,
  LC_IMPRESSION   	VARCHAR2(10) ,
  ID_ARRETE  		NUMBER ,
  ID_SERVICE		NUMBER ,
  ID_FICHE_VOEUX 	NUMBER ,
  ID_REPORT		NUMBER ,
  ID_DEPASSEMENT_PLAFOND NUMBER ,
  ID_TYPE_EDITION  	NUMBER NOT NULL ,
  TEM_EDITION		VARCHAR2(1) DEFAULT 'N' NOT NULL ,
  D_CREATION 		DATE DEFAULT SYSDATE 	NOT NULL ,
  D_EDITION 		DATE DEFAULT SYSDATE 	NOT NULL ,
  PERS_ID_CREATION  	NUMBER 	 NOT NULL ,
  PERS_ID_EDITION 	NUMBER  
);

ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT PK_IMPRESSION PRIMARY KEY(ID_IMPRESSION);
ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT FK_IMP_ARRETE FOREIGN KEY (ID_ARRETE) REFERENCES CSE.ARRETE (ID_ARRETE);
ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT FK_IMP_SERVICE FOREIGN KEY (ID_SERVICE) REFERENCES CSE.SERVICE (ID_SERVICE);
ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT FK_IMP_FICHE_VOEUX FOREIGN KEY (ID_FICHE_VOEUX) REFERENCES CSE.FICHE_VOEUX (ID_FICHE_VOEUX);
ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT FK_IMP_REPORT FOREIGN KEY (ID_REPORT) REFERENCES CSE.REPORT (ID_REPORT);
ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT FK_IMP_ID_DEPASSEMENT_PLAFOND FOREIGN KEY (ID_DEPASSEMENT_PLAFOND) REFERENCES CSE.DEPASSEMENT_PLAFOND (ID_DEPASSEMENT_PLAFOND);
ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT FK_IMP_TYPE_EDITION FOREIGN KEY (ID_TYPE_EDITION) REFERENCES CSE.TYPE_EDITION (ID_TYPE_EDITION);
ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT FK_IMP_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT FK_IMP_PERS_ID_EDITION FOREIGN KEY (PERS_ID_EDITION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.IMPRESSION ADD CONSTRAINT CHK_TE_TEM_EDITION CHECK (TEM_EDITION IN ('O', 'N') );


CREATE INDEX CSE.IDX_IMP_ID_ARRETE ON CSE.IMPRESSION(ID_ARRETE);
CREATE INDEX CSE.IDX_IMP_ID_SER ON CSE.IMPRESSION(ID_SERVICE);
CREATE INDEX CSE.IDX_IMP_ID_FV ON CSE.IMPRESSION(ID_FICHE_VOEUX);
CREATE INDEX CSE.IDX_IMP_ID_REPORT ON CSE.IMPRESSION(ID_REPORT);
CREATE INDEX CSE.IDX_IMP_ID_DP ON CSE.IMPRESSION(ID_DEPASSEMENT_PLAFOND);
CREATE INDEX CSE.IDX_IMP_ID_TE ON CSE.IMPRESSION(ID_TYPE_EDITION);


CREATE SEQUENCE CSE.IMPRESSION_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.IMPRESSION IS 'Table des impressions générées par l''application CSE';    
COMMENT ON COLUMN CSE.IMPRESSION.ID_IMPRESSION IS 'Clef primaire de la table IMPRESSION';
COMMENT ON COLUMN CSE.IMPRESSION.LC_IMPRESSION IS 'Libellé court du type d''édition';
COMMENT ON COLUMN CSE.IMPRESSION.ID_ARRETE IS 'Référence à l''arrêté concerné (cf. CSE.ARRETE.ID_ARRETE)';
COMMENT ON COLUMN CSE.IMPRESSION.ID_SERVICE IS 'Référence à la fiche de service (cf. CSE.SERVICE.ID_SERVICE)';
COMMENT ON COLUMN CSE.IMPRESSION.ID_FICHE_VOEUX IS 'Référence à la fiche de voeux (cf. CSE.FICHE_VOEUX.ID_FICHE_VOEUX)';
COMMENT ON COLUMN CSE.IMPRESSION.ID_REPORT IS 'Référence au report demandé (cf. CSE.REPORT.ID_REPORT)';
COMMENT ON COLUMN CSE.IMPRESSION.ID_DEPASSEMENT_PLAFOND IS 'Référence au dépassement de plafond demandé (cf. CSE.DEPASSEMENT_PLAFOND.ID_DEPASSEMENT_PLAFOND)';
COMMENT ON COLUMN CSE.IMPRESSION.ID_TYPE_EDITION IS 'Code du type d''édition (cf. CSE.TYPE_EDITION.ID_TYPE_EDITION)';
COMMENT ON COLUMN CSE.IMPRESSION.TEM_EDITION IS 'Edition du document ? (O:édité, N:non édité) ';
COMMENT ON COLUMN CSE.IMPRESSION.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.IMPRESSION.D_EDITION IS 'Date de l''édition du document';
COMMENT ON COLUMN CSE.IMPRESSION.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.IMPRESSION.PERS_ID_EDITION IS 'pers_id de la personne à l''origine de l''édition du document';



--
-- CSE_PARAMETRES
--
CREATE TABLE CSE.CSE_PARAMETRES
(
  PARAM_ID        		NUMBER NOT NULL ,
  PARAM_KEY           	VARCHAR2(2000),
  PARAM_VALUE         	VARCHAR2(500) ,
  PARAM_COMMENTAIRES  	VARCHAR2(500) ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER 
);

ALTER TABLE CSE.CSE_PARAMETRES ADD CONSTRAINT PK_CSE_PARAMETRES PRIMARY KEY(PARAM_ID);
ALTER TABLE CSE.CSE_PARAMETRES ADD CONSTRAINT FK_PARAM_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.CSE_PARAMETRES ADD CONSTRAINT FK_PARAM_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
  
CREATE INDEX CSE.IDX_PARAM_PARAM_KEY ON CSE.CSE_PARAMETRES(PARAM_KEY);

CREATE SEQUENCE CSE.CSE_PARAMETRES_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE  CSE.CSE_PARAMETRES IS 'Les paramètres de l''application CSE';
COMMENT ON COLUMN CSE.CSE_PARAMETRES.PARAM_ID IS 'Clef primaire de la table CSE_PARAMETRES.';
COMMENT ON COLUMN CSE.CSE_PARAMETRES.PARAM_KEY IS 'Code du paramètre ';
COMMENT ON COLUMN CSE.CSE_PARAMETRES.PARAM_VALUE IS 'Valeur du paramètre';
COMMENT ON COLUMN CSE.CSE_PARAMETRES.PARAM_COMMENTAIRES IS 'Commentaire du paramètre';
COMMENT ON COLUMN CSE.CSE_PARAMETRES.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN CSE.CSE_PARAMETRES.D_MODIFICATION IS 'Date de la dernière modification de l''enregistrement.';
COMMENT ON COLUMN CSE.CSE_PARAMETRES.PERS_ID_CREATION IS 'Pers_id de la personne à l''origine de la création de l''enregistrement.';
COMMENT ON COLUMN CSE.CSE_PARAMETRES.PERS_ID_MODIFICATION IS 'Pers_id de la personne à l''origine de la modification de l''enregistrement.';


--
-- TARIF
--
CREATE TABLE CSE.TARIF
(
  ID_TARIF			NUMBER NOT NULL ,
  TAUX_BRUT			NUMBER ,
  TAUX_CHARGE_FONCTIONNAIRE 	NUMBER ,
  TAUX_CHARGE_NON_FONCTIONNAIRE	NUMBER ,
  D_DEBUT 			DATE DEFAULT SYSDATE NOT NULL,
  D_FIN  			DATE DEFAULT SYSDATE ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  		NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 		NUMBER  
);

ALTER TABLE CSE.TARIF ADD CONSTRAINT PK_TARIF PRIMARY KEY(ID_TARIF);
ALTER TABLE CSE.TARIF ADD CONSTRAINT FK_TAR_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.TARIF ADD CONSTRAINT FK_TAR_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE SEQUENCE CSE.TARIF_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.TARIF IS 'Table des tarifs appliqués pour les paiements des intervenants';    
COMMENT ON COLUMN CSE.TARIF.ID_TARIF IS 'Clef primaire de la table TARIF';
COMMENT ON COLUMN CSE.TARIF.TAUX_BRUT IS 'Taux brut appliqué à toutes populations confondus';
COMMENT ON COLUMN CSE.TARIF.TAUX_CHARGE_FONCTIONNAIRE IS 'Taux chargé pour les fonctionnaires uniquement';
COMMENT ON COLUMN CSE.TARIF.TAUX_CHARGE_NON_FONCTIONNAIRE IS 'Taux chargé pour les non fonctionnaires uniquement';
COMMENT ON COLUMN CSE.TARIF.D_DEBUT IS 'Date du début d''application du tarif';
COMMENT ON COLUMN CSE.TARIF.D_FIN IS 'Date de fin d''application du tarif';
COMMENT ON COLUMN CSE.TARIF.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.TARIF.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.TARIF.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.TARIF.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- TYPE_HORAIRE
--
CREATE TABLE CSE.TYPE_HORAIRE
(
  ID_TYPE_HORAIRE	NUMBER(2) NOT NULL ,
  C_TYPE_HORAIRE   	VARCHAR2(10) ,
  LC_TYPE_HORAIRE   	VARCHAR2(20) ,
  LL_TYPE_HORAIRE   	VARCHAR2(60) ,
  D_CREATION 		DATE DEFAULT SYSDATE 	NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE 	NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER  
);

ALTER TABLE CSE.TYPE_HORAIRE ADD CONSTRAINT PK_TYPE_HORAIRE PRIMARY KEY(ID_TYPE_HORAIRE);
ALTER TABLE CSE.TYPE_HORAIRE  ADD CONSTRAINT UK_TYPE_HORAIRE  UNIQUE (C_TYPE_HORAIRE);
ALTER TABLE CSE.TYPE_HORAIRE ADD CONSTRAINT FK_TH_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.TYPE_HORAIRE ADD CONSTRAINT FK_TH_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE SEQUENCE CSE.TYPE_HORAIRE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.TYPE_HORAIRE IS 'Nomenclature des codes de l''AP';    
COMMENT ON COLUMN CSE.TYPE_HORAIRE.ID_TYPE_HORAIRE IS 'Clef primaire de la table TYPE_HORAIRE ';
COMMENT ON COLUMN CSE.TYPE_HORAIRE.C_TYPE_HORAIRE IS 'Code de l''AP';
COMMENT ON COLUMN CSE.TYPE_HORAIRE.LC_TYPE_HORAIRE IS 'Libellé court de l''AP';
COMMENT ON COLUMN CSE.TYPE_HORAIRE.LL_TYPE_HORAIRE IS 'Libellé long de l''AP';
COMMENT ON COLUMN CSE.TYPE_HORAIRE.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.TYPE_HORAIRE.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.TYPE_HORAIRE.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.TYPE_HORAIRE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- PARAM_POP_HETD
--
CREATE TABLE CSE.PARAM_POP_HETD
(
  ID_PARAM_POP_HETD		NUMBER NOT NULL ,
  C_TYPE_CONTRAT_TRAV 		VARCHAR2(2) ,
  C_CORPS 			VARCHAR2(4) ,
  ID_TYPE_HORAIRE  			NUMBER(2) NOT NULL ,
  NUMERATEUR_SERVICE	NUMBER NOT NULL,
  DENOMINATEUR_SERVICE	NUMBER DEFAULT 1 NOT NULL, 
  NUMERATEUR_HCOMP		NUMBER ,
  DENOMINATEUR_HCOMP	NUMBER , 
  D_DEBUT 			DATE DEFAULT SYSDATE NOT NULL,
  D_FIN  			DATE ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  		NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 		NUMBER  
);

ALTER TABLE CSE.PARAM_POP_HETD ADD CONSTRAINT PK_PARAM_POP_HETD PRIMARY KEY(ID_PARAM_POP_HETD);
ALTER TABLE CSE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_C_TYPE_CONTRAT_TRAV FOREIGN KEY (C_TYPE_CONTRAT_TRAV) REFERENCES GRHUM.TYPE_CONTRAT_TRAVAIL (C_TYPE_CONTRAT_TRAV);
ALTER TABLE CSE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_C_CORPS FOREIGN KEY (C_CORPS) REFERENCES GRHUM.CORPS (C_CORPS);
-- Un des 2 identifiants (C_TYPE_CONTRAT_TRAV, C_CORPS) doit être renseigné au plus, mais également un des deux doit être renseigné au moins.
ALTER TABLE CSE.PARAM_POP_HETD ADD CONSTRAINT PPH_TCT_CORPS_NULLS CHECK (C_TYPE_CONTRAT_TRAV IS NOT NULL OR C_CORPS IS NOT NULL);
ALTER TABLE CSE.PARAM_POP_HETD ADD CONSTRAINT PPH_TCT_CORPS_NOT_NULLS CHECK (C_TYPE_CONTRAT_TRAV IS NULL OR C_CORPS IS NULL);
ALTER TABLE CSE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_TYPE_HORAIRE FOREIGN KEY (ID_TYPE_HORAIRE) REFERENCES CSE.TYPE_HORAIRE (ID_TYPE_HORAIRE);
ALTER TABLE CSE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);


CREATE INDEX CSE.IDX_PPH_C_TYPE_CONTRAT_TRAV ON CSE.PARAM_POP_HETD(C_TYPE_CONTRAT_TRAV);
CREATE INDEX CSE.IDX_PPH_C_CORPS ON CSE.PARAM_POP_HETD(C_CORPS);
CREATE INDEX CSE.IDX_PPH_TYPE_HORAIRE ON CSE.PARAM_POP_HETD(ID_TYPE_HORAIRE);

CREATE SEQUENCE CSE.PARAM_POP_HETD_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.PARAM_POP_HETD IS 'Table qui définit les heures en équivalent TD des AP(CM, TD,...) en fonction de la population';    
COMMENT ON COLUMN CSE.PARAM_POP_HETD.ID_PARAM_POP_HETD IS 'Clef primaire de la table PARAM_POP_HETD';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.C_TYPE_CONTRAT_TRAV IS 'Type de population concernée parmi les contractuels(cf. GRHUM.TYPE_CONTRAT_TRAVAIL.C_TYPE_CONTRAT_TRAV)';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.C_CORPS IS 'Type de population concernée parmi les titulaires (cf. GRHUM.CORPS.C_CORPS)';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.ID_TYPE_HORAIRE IS 'Type du code de l''AP (cf. CSE.TYPE_HORAIRE.ID_TYPE_HORAIRE)';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.NUMERATEUR_SERVICE IS 'Numérateur du coefficient pour le calcul de l''AP dans le service';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.DENOMINATEUR_SERVICE IS 'Dénominateur du coefficient pour le calcul de l''AP dans le service';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.NUMERATEUR_HCOMP IS 'Numérateur du coefficient pour le calcul de l''AP en dehors du service dû';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.DENOMINATEUR_HCOMP IS 'Dénominateur du coefficient pour le calcul de l''AP en dehors du service dû';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.D_DEBUT IS 'Date du début d''application de l''équivalence';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.D_FIN IS 'Date de fin d''application de l''équivalence';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.PARAM_POP_HETD.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- PARAM_UTILISATEUR
--
CREATE TABLE CSE.PARAM_UTILISATEUR
(
  ID_PARAM_UTILISATEUR		NUMBER NOT NULL ,
  ASS_ID      			NUMBER ,
  TEM_VALIDATION_VACATAIRE	VARCHAR2(1) DEFAULT 'N' NOT NULL ,
  TEM_VALIDATION_AUTRES		VARCHAR2(1) DEFAULT 'N' NOT NULL ,
  TEM_CONSULTATION		VARCHAR2(1) DEFAULT 'N' NOT NULL ,
  TEM_REQUETE			VARCHAR2(1) DEFAULT 'N' NOT NULL ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  		NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 		NUMBER    
);

ALTER TABLE CSE.PARAM_UTILISATEUR ADD CONSTRAINT PK_PARAM_UTILISATEUR PRIMARY KEY(ID_PARAM_UTILISATEUR);
ALTER TABLE CSE.PARAM_UTILISATEUR ADD CONSTRAINT FK_PU_ASS_ID FOREIGN KEY (ASS_ID) REFERENCES GRHUM.ASSOCIATION (ASS_ID);
ALTER TABLE CSE.PARAM_UTILISATEUR ADD CONSTRAINT CHK_PU_TEM_VALID_VACATAIRE CHECK (TEM_VALIDATION_VACATAIRE IN ('O', 'N') );
ALTER TABLE CSE.PARAM_UTILISATEUR ADD CONSTRAINT CHK_PU_TEM_VALIDATION_AUTRES CHECK (TEM_VALIDATION_AUTRES IN ('O', 'N') );
ALTER TABLE CSE.PARAM_UTILISATEUR ADD CONSTRAINT CHK_PU_TEM_CONSULTATION CHECK (TEM_CONSULTATION IN ('O', 'N') );
ALTER TABLE CSE.PARAM_UTILISATEUR ADD CONSTRAINT CHK_PU_TEM_REQUETE CHECK (TEM_REQUETE IN ('O', 'N') );
ALTER TABLE CSE.PARAM_UTILISATEUR ADD CONSTRAINT FK_PU_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.PARAM_UTILISATEUR ADD CONSTRAINT FK_PU_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);


CREATE INDEX CSE.IDX_PU_ASS_ID ON CSE.PARAM_UTILISATEUR(ASS_ID);

CREATE SEQUENCE CSE.PARAM_UTILISATEUR_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.PARAM_UTILISATEUR IS 'Table où sont définis les profils utilisés dans l''application';    
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.ID_PARAM_UTILISATEUR IS 'Clef primaire de la table PARAM_UTILISATEUR';
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.ASS_ID IS 'Référence à l''association utilisée  (cf. GRHUM.ASSOCIATION.ASS_ID)';
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.TEM_VALIDATION_VACATAIRE IS 'Droit de valider le circuit de validation des vacataires? O:oui, N:non';
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.TEM_VALIDATION_AUTRES IS 'Droit de valider le circuit de validation des non vacataires? O:oui, N:non';
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.TEM_CONSULTATION IS 'Droit de consultation dans l''application? O:oui, N:non';
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.TEM_REQUETE IS 'Droit de requêter dans l''application? O:oui, N:non';
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.PARAM_UTILISATEUR.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


/*
--
-- REPART_NATURE_FINANCEMENT
--
CREATE TABLE CSE.REPART_NATURE_FINANCEMENT
(
  ID_RNF				NUMBER NOT NULL ,
  ID_NE  				NUMBER	NOT NULL ,
  ID_TYPE_FINANCEMENT  				NUMBER(2) NOT NULL ,
  ID_TUF  				NUMBER(2) NOT NULL ,
  D_DEBUT 				DATE DEFAULT SYSDATE ,
  D_FIN  				DATE DEFAULT SYSDATE ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER  
);

ALTER TABLE CSE.REPART_NATURE_FINANCEMENT ADD CONSTRAINT PK_REPART_NATURE_FINANCEMENT PRIMARY KEY(ID_RNF);
ALTER TABLE CSE.REPART_NATURE_FINANCEMENT ADD CONSTRAINT FK_RNF_ELEMENT_MAQUETTE FOREIGN KEY (ID_NE) REFERENCES CSE.ELEMENT_MAQUETTE (ID_NE);
ALTER TABLE CSE.REPART_NATURE_FINANCEMENT ADD CONSTRAINT FK_RNF_TYPE_FINANCEMENT FOREIGN KEY (ID_TYPE_FINANCEMENT) REFERENCES GRHUM.TYPE_FINANCEMENT (ID_TYPE_FINANCEMENT);
ALTER TABLE CSE.REPART_NATURE_FINANCEMENT ADD CONSTRAINT FK_TYPE_UNITE_FINANCEMENT FOREIGN KEY (ID_TUF) REFERENCES GRHUM.TYPE_UNITE_FINANCEMENT (ID_TUF);
ALTER TABLE CSE.REPART_NATURE_FINANCEMENT ADD CONSTRAINT FK_RNF_PERS_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.REPART_NATURE_FINANCEMENT ADD CONSTRAINT FK_RNF_PERS_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE INDEX CSE.IDX_RNF_ID_NE ON CSE.REPART_NATURE_FINANCEMENT(ID_NE);
CREATE INDEX CSE.IDX_RNF_ID_TF ON CSE.REPART_NATURE_FINANCEMENT(ID_TYPE_FINANCEMENT);
CREATE INDEX CSE.IDX_RNF_ID_TUF ON CSE.REPART_NATURE_FINANCEMENT(ID_TUF);

CREATE SEQUENCE CSE.REPART_NATURE_FINANCEMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.REPART_NATURE_FINANCEMENT IS 'Table où sont répartis les éléments présents dans l''offre de formation en fonction du type de financement et son unité';    
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.ID_RNF IS 'Clef primaire de la table REPART_NATURE_FINANCEMENT';
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.ID_NE IS 'Référence à l''élément présent dans l''offre de formation (cf. CSE.ELEMENT_MAQUETTE.ID_NE)';
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.ID_TYPE_FINANCEMENT IS 'Référence au type de financement (cf. GRHUM.TYPE_FINANCEMENT.ID_TYPE_FINANCEMENT)';
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.ID_TUF IS 'Référence à l''unité de financement (cf. GRHUM.TYPE_UNITE_FINANCEMENT.ID_TUF)';
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.D_DEBUT IS 'Date du début de la répartition';
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.D_FIN IS 'Date de fin de la répartition';
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.REPART_NATURE_FINANCEMENT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';

*/

--
-- REPART_ELEMENT
--
CREATE TABLE CSE.REPART_ELEMENT
(
  ID_REPART_ELEMENT		NUMBER NOT NULL ,
  ID_NE  			NUMBER	NOT NULL ,
  ID_PARAM_UTILISATEUR		NUMBER NOT NULL ,
  NO_INDIVIDU   		NUMBER(8, 0)	NOT NULL ,
  D_DEBUT 			DATE DEFAULT SYSDATE ,
  D_FIN  			DATE DEFAULT SYSDATE ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER 
);

ALTER TABLE CSE.REPART_ELEMENT ADD CONSTRAINT PK_REPART_ELEMENT PRIMARY KEY(ID_REPART_ELEMENT);
ALTER TABLE CSE.REPART_ELEMENT ADD CONSTRAINT FK_REL_ELEMENT_MAQUETTE FOREIGN KEY (ID_NE) REFERENCES CSE.ELEMENT_MAQUETTE (ID_NE);
ALTER TABLE CSE.REPART_ELEMENT ADD CONSTRAINT FK_REL_PARAM_UTILISATEUR FOREIGN KEY (ID_PARAM_UTILISATEUR) REFERENCES CSE.PARAM_UTILISATEUR (ID_PARAM_UTILISATEUR);
ALTER TABLE CSE.REPART_ELEMENT ADD CONSTRAINT FK_REL_INDIVIDU FOREIGN KEY (NO_INDIVIDU) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE CSE.REPART_ELEMENT ADD CONSTRAINT FK_REL_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.REPART_ELEMENT ADD CONSTRAINT FK_REL_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE INDEX CSE.IDX_REL_ID_NE ON CSE.REPART_ELEMENT(ID_NE);
CREATE INDEX CSE.IDX_REL_ID_PU ON CSE.REPART_ELEMENT(ID_PARAM_UTILISATEUR);
CREATE INDEX CSE.IDX_REL_INDIVIDU ON CSE.REPART_ELEMENT(NO_INDIVIDU);

CREATE SEQUENCE CSE.REPART_ELEMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.REPART_ELEMENT IS 'Table où sont affectés les éléments de l''offre de formation au profil d''utilisateur qui s''en occupe';    
COMMENT ON COLUMN CSE.REPART_ELEMENT.ID_REPART_ELEMENT IS 'Clef primaire de la table REPART_ELEMENT';
COMMENT ON COLUMN CSE.REPART_ELEMENT.ID_NE IS 'Référence à l''élément présent dans l''offre de formation (cf. CSE.ELEMENT_MAQUETTE.ID_NE)';
COMMENT ON COLUMN CSE.REPART_ELEMENT.ID_PARAM_UTILISATEUR IS 'Référence au profil d''utilisateur concerné (cf. CSE.PARAM_UTILISATEUR.ID_PARAM_UTILISATEUR)';
COMMENT ON COLUMN CSE.REPART_ELEMENT.NO_INDIVIDU IS 'Référence à l''individu concerné (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN CSE.REPART_ELEMENT.D_DEBUT IS 'Date du début de la répartition';
COMMENT ON COLUMN CSE.REPART_ELEMENT.D_FIN IS 'Date de fin de la répartition';
COMMENT ON COLUMN CSE.REPART_ELEMENT.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.REPART_ELEMENT.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.REPART_ELEMENT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.REPART_ELEMENT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- REPART_ENSEIGNANT
--
CREATE TABLE CSE.REPART_ENSEIGNANT
(
  ID_REPART_ENSEIGNANT				NUMBER NOT NULL ,
  ID_SERVICE		 		NUMBER	NOT NULL ,
  NO_INDIVIDU_REF 		NUMBER NOT NULL ,
  NO_INDIVIDU_AUTRE		NUMBER NOT NULL ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER 
);

ALTER TABLE CSE.REPART_ENSEIGNANT ADD CONSTRAINT PK_REPART_ENSEIGNANT PRIMARY KEY(ID_REPART_ENSEIGNANT);
ALTER TABLE CSE.REPART_ENSEIGNANT ADD CONSTRAINT FK_REN_SERVICE FOREIGN KEY (ID_SERVICE) REFERENCES CSE.SERVICE (ID_SERVICE);
ALTER TABLE CSE.REPART_ENSEIGNANT ADD CONSTRAINT FK_REN_INDIVIDU_REF FOREIGN KEY (NO_INDIVIDU_REF) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE CSE.REPART_ENSEIGNANT ADD CONSTRAINT FK_REN_INDIVIDU_AUTRE FOREIGN KEY (NO_INDIVIDU_AUTRE) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE CSE.REPART_ENSEIGNANT ADD CONSTRAINT FK_REN_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.REPART_ENSEIGNANT ADD CONSTRAINT FK_REN_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE INDEX CSE.IDX_REN_ID_SER ON CSE.REPART_ENSEIGNANT(ID_SERVICE);
CREATE INDEX CSE.IDX_REN_NO_INDIVIDU_REF ON CSE.REPART_ENSEIGNANT(NO_INDIVIDU_REF);
CREATE INDEX CSE.IDX_REN_NO_INDIVIDU_AUTRE ON CSE.REPART_ENSEIGNANT(NO_INDIVIDU_AUTRE);

CREATE SEQUENCE CSE.REPART_ENSEIGNANT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.REPART_ENSEIGNANT IS 'Table où sont listés le répartiteur référent d''un enseignant et un autre répartiteur qui veut affecter des heures à cet enseignant';    
COMMENT ON COLUMN CSE.REPART_ENSEIGNANT.ID_REPART_ENSEIGNANT IS 'Clef primaire de la table REPART_ENSEIGNANT';
COMMENT ON COLUMN CSE.REPART_ENSEIGNANT.ID_SERVICE IS 'Référence au service de l''enseignant concerné (cf. CSE.SERVICE.ID_SERVICE)';
COMMENT ON COLUMN CSE.REPART_ENSEIGNANT.NO_INDIVIDU_REF IS 'Référence au répartiteur référent de l''enseignant (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN CSE.REPART_ENSEIGNANT.NO_INDIVIDU_AUTRE IS 'Référence à un autre répartiteur (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN CSE.REPART_ENSEIGNANT.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.REPART_ENSEIGNANT.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.REPART_ENSEIGNANT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.REPART_ENSEIGNANT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
--  TEMOIN
--
CREATE TABLE CSE.TEMOIN
(
  ID_TEMOIN		NUMBER(8) NOT NULL ,
  C_TEMOIN		VARCHAR2(20),
  PERS_ID		NUMBER ,
  TEM_CONFIRME		VARCHAR2(1) DEFAULT 'N' NOT NULL ,
  D_CREATION 		DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER  
);

ALTER TABLE CSE.TEMOIN ADD CONSTRAINT PK_TEMOIN PRIMARY KEY(ID_TEMOIN);
ALTER TABLE CSE.TEMOIN ADD CONSTRAINT FK_TEM_PERS_ID FOREIGN KEY (PERS_ID) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.TEMOIN ADD CONSTRAINT FK_TEM_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.TEMOIN ADD CONSTRAINT FK_TEM_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE CSE.TEMOIN ADD CONSTRAINT CHK_TEM_TEM_CONFIRME CHECK (TEM_CONFIRME IN ('O', 'N') );

CREATE INDEX CSE.IDX_TEM_PERS_ID ON CSE.TEMOIN(PERS_ID);
CREATE INDEX CSE.IDX_TEM_C_TEMOIN ON CSE.TEMOIN(C_TEMOIN);
CREATE SEQUENCE CSE.TEM_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;


COMMENT ON TABLE CSE.TEMOIN IS 'Table des témoins et leurs états utilisés par l''application';    
COMMENT ON COLUMN CSE.TEMOIN.ID_TEMOIN IS 'Clef primaire de la table TEMOIN';
COMMENT ON COLUMN CSE.TEMOIN.C_TEMOIN IS 'Code du témoin';
COMMENT ON COLUMN CSE.TEMOIN.PERS_ID IS 'pers_id de l''intervenant concerné';
COMMENT ON COLUMN CSE.TEMOIN.TEM_CONFIRME IS 'Confirmation de l''enregistrement ? (O:oui, N:non)';
COMMENT ON COLUMN CSE.TEMOIN.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN CSE.TEMOIN.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN CSE.TEMOIN.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN CSE.TEMOIN.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
--  V_PERSONNEL_ACTUEL_ENS
--
CREATE OR REPLACE VIEW CSE.V_PERSONNEL_ACTUEL_ENS (NO_DOSSIER_PERS, TEM_TITULAIRE)
AS
  --Enseignant titulaire 
  SELECT
    c.no_dossier_pers, 'O'
  FROM
    MANGUE.element_carriere c,
    GRHUM.corps co,
    GRHUM.type_population tp
  WHERE
    (
      c.d_effet_element <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
    AND
      (
        c.d_fin_element  IS NULL
      OR c.d_fin_element >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND c.tem_valide    = 'O'
  AND c.c_corps       = co.c_corps
  AND co.c_type_corps = tp.c_type_population
  AND
    (
      tp.tem_enseignant = 'O'
    OR tp.tem_2degre    = 'O'
    OR tp.tem_ens_sup   = 'O'
    )
  UNION
  -- inclusion des contrats enseignant au niveau réglementaire
  SELECT
    c.no_dossier_pers, 'N'
  FROM
    MANGUE.contrat c,
    GRHUM.type_contrat_travail tct
  WHERE
    (
      c.d_deb_contrat_trav <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    AND
      (
        c.d_fin_contrat_trav                  IS NULL
      OR ADD_MONTHS (c.d_fin_contrat_trav, 1) >= TO_DATE (TO_CHAR (SYSDATE,
        'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND tct.droit_conges_contrat         = 'O'
  AND c.tem_annulation                 = 'N'
  AND tct.tem_enseignant               = 'O'
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  AND tct.tem_remuneration_accessoire != 'O'
  AND tct.tem_titulaire               != 'O'
  AND tct.tem_invite_associe          != 'O'
  UNION
  -- inclusion des contrats non enseignant typés enseignant
  SELECT
    c.no_dossier_pers, 'N'
  FROM
    MANGUE.CONTRAT_VACATAIRES v,
    MANGUE.CONTRAT c ,
    GRHUM.TYPE_CONTRAT_TRAVAIL tct
  WHERE
    c.no_seq_contrat  = v.no_seq_contrat
  AND v.tem_enseignant='O'
  AND
    (
      c.d_deb_contrat_trav   <= SYSDATE
    AND ( c.d_fin_contrat_trav IS NULL
          OR c.d_fin_contrat_trav  >= SYSDATE
        )
    )
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  AND c.tem_annulation                 = 'N'
  AND tct.TEM_REMUNERATION_ACCESSOIRE != 'O'
  AND tct.TEM_TITULAIRE               != 'O'
  UNION
  -- inclusion des contrats non enseignant typés par le
  -- typepopulation enseignant pour des fonctionnaires
  SELECT
    no_dossier_pers, 'N'
  FROM
    MANGUE.contrat c,
    GRHUM.type_contrat_travail tct,
    MANGUE.contrat_avenant ca,
    GRHUM.grade g,
    GRHUM.corps c,
    GRHUM.type_population tp
  WHERE
    (
      c.d_deb_contrat_trav <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
    AND
      (
        c.d_fin_contrat_trav IS NULL
      OR ADD_MONTHS (c.d_fin_contrat_trav, 1) >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND tct.droit_conges_contrat         = 'O'
  AND c.tem_annulation                 = 'N'
  AND tct.tem_enseignant               = 'O'
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  AND tct.tem_remuneration_accessoire != 'O'
  AND tct.tem_titulaire               != 'O'
  AND c.no_seq_contrat                 = ca.no_seq_contrat
  AND ca.c_grade                       = g.c_grade
  AND g.c_corps                        = c.c_corps
  AND c.c_type_corps                   = tp.c_type_population
  AND tp.tem_enseignant                = 'O'
  AND ca.tem_annulation                = 'N'
  AND ca.d_deb_contrat_av             <= TO_DATE (TO_CHAR (SYSDATE,
    'dd/mm/YYYY'), 'dd/mm/YYYY')
  AND
    (
      ca.d_fin_contrat_av IS NULL
    OR ADD_MONTHS (ca.d_fin_contrat_av, 1) >= TO_DATE (TO_CHAR (SYSDATE,
      'dd/mm/YYYY'), 'dd/mm/YYYY')
    )
  UNION
  -- Prise en compte des Professeurs émérites
  SELECT
    no_dossier_pers, 'N'
  FROM
    MANGUE.emeritat E
  WHERE
    E.D_DEB_EMERITAT <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
  AND
    (
      E.D_FIN_EMERITAT  IS NULL
      OR E.D_FIN_EMERITAT >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    );
   
   

COMMIT;
